<?php
// Access Logger Day Log

include_once("ALSLog.php");
include_once("AL_func.php");

class ALDLog{
    var $sLog = array();
    var $memo = array();
    
    function ALDLog($log_file){
        $data = @file($log_file);
        if($data){
            while(list($key,$val) = each($data)){
                if(eregi("^\*",$val)){
                    $s_log = new ALSLog($val);
                    while(list($key,$val) = each($data)){
                        if(eregi("^\n$",$val)){
                            break;
                        }
                        elseif(eregi("^-",$val)){
                            $s_log->setTLog($val);
                        }
                    }
                    array_push($this->sLog,$s_log);
                }
                elseif(eregi("^\+",$val)){
                    $memo_arr = explode("\t",$val);
                    $memo_temp = trim($memo_arr[2]);
                    $this->memo += array($memo_arr[1] => $memo_temp);
                }
            }
        }
        else{
            echo "error: log file $log_file is not found!\n";
            exit;
        }
    }
    
    // get array of session log
    function getSLog(){ return $this->sLog; }
    
    // get the number of sessions
    function getCount(){ return count($this->sLog); }
    
    // get the number of page view
    function getPageView(){
        $s_log_arr = $this->sLog;
        $d_pv = 0;
        while(list($key,$s_log) = each($s_log_arr)){
            $s_pv = $s_log->getSessInfo('PageView');
            $d_pv += $s_pv;
        }
        return $d_pv;
    }
    
    // get the number of page view per hour
    function getHourPV(){
        $s_log_arr = $this->sLog;
        $d_pv = array();
        $s_log_arr = $this->sLog;
        while(list($key,$s_log) = each($s_log_arr)){
            $s_pv = $s_log->getSessInfo('HourPV');
            while(list($h,$pv) = each($s_pv)){
                $d_pv[$h] += $pv;
            }
        }
        return $d_pv;
    }
    
    // get the number of page view per hour
    function getHour(){
        $hour = $this->getList('Hour');
        $hour_pv = $this->getHourPV();
        return array($hour,$hour_pv);
    }
    
    // get the number of list
    function getList($mode){
        switch($mode){
            case "AccUrl":
                return $this->getAccUrl();
            case "RefUrl":
                return $this->getReferer("");
            case "Search":
                return $this->getReferer("se");
            case "Memo":
                return $this->memo;
        }
        $array = array();
        $s_log_arr = $this->sLog;
        while(list($s_key, $s_log) = each($s_log_arr)){
            switch($mode){
                case "Domain":
                    $s_data = $this->getDomain($s_log,"do");
                    break;
                case "Country":
                    $s_data = $this->getDomain($s_log,"co");
                    break;
                case "Browser":
                    $s_data = $this->getAgent($s_log,"br");
                    break;
                case "Os":
                    $s_data = $this->getAgent($s_log,"os");
                    break;
                default:
                    $s_data = $s_log->getSessInfo($mode);
                    break;
            }
            if($s_data == false){
                continue;
            }
            $array[$s_data] += 1;
        }
        return $array;
    }
    
    // get the number of accessed url
    function getAccUrl(){
        $acc_url_arr = array();
        $s_log_arr = $this->sLog;
        while(list($s_key,$s_log) = each($s_log_arr)){
            $acc_url = $s_log->getSessInfo('AccUrl');
            if(isset($acc_url_arr[$acc_url])){
                ++$acc_url_arr[$acc_url];
            }
            else{
                $acc_url_arr += array($acc_url => 1);
            }
            $t_log_arr = $s_log->getSessInfo('Track');
            while(list($t_key,$t_log) = each($t_log_arr)){
                $acc_url = $t_log->getTrackInfo('AccUrl');
                if(isset($acc_url_arr[$acc_url])){
                    ++$acc_url_arr[$acc_url];
                }
                else{
                    $acc_url_arr += array($acc_url => 1);
                }
            }
        }
        return $acc_url_arr;
    }
    
    // get the number of referer url
    function getReferer($mode){
        $ref_arr = array();
        $s_log_arr = $this->sLog;
        while(list($s_key, $s_log) = each($s_log_arr)){
            $ref = $s_log->getSessInfo('RefUrl');
            if(!eregi("^http:\/\/",$ref) && !eregi("^Bookmark$",$ref)){
                continue;
            }
            if(eregi("^http:\/\/",$ref)){
                $engine = keywords($ref);
                if($engine[1] == ""){
                    $ref = $engine[0];
                }
                else{
                    $ref = $engine[3];
                }
            }
                
            // [begin] to get search word
            if($mode == "se"){
                $search_word = $engine[1];
                if($search_word == "" || eregi("^Bookmark$",$ref)){
                    continue;
                }
                else{
                    $ref = $search_word;
                }
            }
            // [end]
                
            $ref_arr[$ref] += 1;
            
            $t_log_arr = $s_log->getSessInfo('Track');
            while(list($t_key,$t_log) = each($t_log_arr)){
                $ref = $t_log->getTrackInfo('RefUrl');
                $ref = trim($ref);
                if(!eregi("^http:\/\/",$ref) && !eregi("^Bookmark$",$ref)){
                    continue;
                }
                if(eregi("^http:\/\/",$ref)){
                    $engine = keywords($ref);
                    if($engine[1] == ""){
                        $ref = $engine[0];
                    }
                    else{
                        $ref = $engine[3];
                    }
                }
                    
                // [begin] to get search word
                if($mode == "se"){
                    $search_word = $engine[1];
                    if($search_word == "" || eregi("^Bookmark$",$ref)){
                        continue;
                    }
                    else{
                        $ref = $search_word;
                    }
                }
                // [end]
                    
                $ref_arr[$ref] += 1;
            }
        }
        return $ref_arr;
    }
    
    // get the number of domain
    function getDomain($s_log,$mode){
        global $level1;
        global $level2;
        $domain = $s_log->getSessInfo('Host');
        $ip = $s_log->getSessInfo('Ip');
        if(ereg($domain,$ip)){
            return false;
        }
        $do = explode(".",$domain);
        $end = count($do) - 1;
        
        // [begin] to get first level domain
        if($mode == "co"){
            $country = strtolower($do[$end]);
            return $country;
        }
        // [end]
        
        if(in_array($do[$end],$level1)){
            $domain = $do[$end - 1].".".$do[$end ];
        }
        elseif(eregi("jp",$do[$end]) && !in_array($do[$end-1],$level2)){
            $domain = $do[$end - 1].".".$do[$end ];
        }
        else{
            $domain = $do[$end - 2].".".$do[$end - 1].".".$do[$end];
        }
        return $domain;
    }
    
    // get the number of agent
    function getAgent($s_log,$mode){
        $list = $mode."_list";
        $img_list = $mode."_img_list";
        global $$list;
        global $$img_list;
        $agent = $s_log->getSessInfo('Agent');
        $unknown_flag = true;
        reset($$list);
        while(list($temp_key,$temp) = each($$list)){
            if(eregi($temp_key,$agent)){
                $agent_temp = $temp;
                reset($$img_list);
                while(list($temp_img_key,$temp_img) = each($$img_list)){
                    if(eregi($temp_img_key,$agent_temp)){
                        $agent_temp = "<img src=\"img/".$temp_img."\"> ".$agent_temp;
                    }
                }
                $unknown_flag = false;
                break;
            }
        }
        if($unknown_flag){
            $agent_temp = $agent;
            //$agent_temp = "unknown";
        }
        return $agent_temp;
    }
    
}
?>
