<?php
// Access Logger Month Log
include_once("AL_conf.php");
include_once("ALDLog.php");

class ALMLog{
    var $dLog = array();
    
    function ALMLog($month){ // $month: YYYY-mm
        global $AL_logdir;
        $logdir = "../".$AL_logdir."/".$month."/";
        $i = 1;
        while($i<=31){
            $d = (string)floor($i/10).(string)($i%10);
            $date = $month."-".$d;
            $log_file = $logdir.$date."_log.txt";
            if(!file_exists($log_file)){
                ++$i;
                continue;
            }
            $d_log = new ALDLog($log_file);
            $this->dLog += array($date => $d_log);
            ++$i;
        }
    }
    
    // get the count of each days
    function getDay(){
        $days_count = array();
        $days_pv = array();
        $d_log_arr = $this->dLog;
        while(list($d_key, $d_log) = each($d_log_arr)){
            $d_count = $d_log->getCount();
            $d_pv = $d_log->getPageView();
            $days_count += array($d_key => $d_count);
            $days_pv += array($d_key => $d_pv);
        }
        return array($days_count, $days_pv);
    }
    
    // get the number of page view per hour
    function getHour(){
        $hour = array();
        $hour_pv = array();
        $d_log_arr = $this->dLog;
        while(list($d_key, $d_log) = each($d_log_arr)){
            $h_count = $d_log->getList('Hour');
            while(list($h,$val) = each($h_count)){
                $hour[$h] += $val;
            }
            $h_pv = $d_log->getHourPV();
            while(list($h,$val) = each($h_pv)){
                $hour_pv[$h] += $val;
            }
        }
        return array($hour,$hour_pv);
    }
    
    // get log of a day
    function getDLog($date){ // YYYY-mm-dd
        $d_log = $this->dLog[$date];
        return $d_log;
    }
    
    // get the number of host
    function getList($mode){ // YYYY-mm
        $array = array();
        $d_log_arr = $this->dLog;
        while(list($d_key, $d_log) = each($d_log_arr)){
            $d_array = $d_log->getList($mode);
            switch($mode){
                case "Memo":
                    $array += $d_array;
                    break;
                default:
                    while(list($key,$val) = each($d_array)){
                        if(isset($array[$key])){
                            $array[$key] += $val;
                        }
                        else{
                            $array += array($key => $val);
                        }
                    }
                    break;
            }
        }
        return $array;
    }
}
?>
