<?php
// Access Logger Session Log

include_once("ALTLog.php");

class ALSLog{
    var $time;
    var $ip;
    var $accUrl;
    var $refUrl;
    var $host;
    var $agent;
    var $screen;
    var $color;
    var $java;
    var $javaScript;
    var $track = array();
    
    function ALSLog($str){
        $log_info = explode("\t",$str);
        $this->time = trim($log_info[1]);
        $this->ip = trim($log_info[2]);
        $this->accUrl = trim($log_info[3]);
        $this->refUrl = trim($log_info[4]);
        $this->host = trim($log_info[5]);
        $this->agent = trim($log_info[6]);
        $this->screen = trim($log_info[7]);
        $this->color = trim($log_info[8]);
        $this->java = trim($log_info[9]);
        $this->javaScript = trim($log_info[10]);
    }
    
    // set track logs
    function setTLog($str){
        $track_log = new ALTLog($str);
        array_push($this->track, $track_log);
    }
    
    // get the number of page view
    function getPageView(){
        $page_view = count($this->track) + 1;
        return $page_view;
    }
    
    // get time stamp
    function getTimeStamp(){
        $time = explode(" ", $this->time);
        $d = explode("-", $time[0]);
        $t = explode(":", $time[1]);
        if(!isset($time[2])){
            $time[2] = "00";
        }
        $time_stamp = mktime((int)$t[0],(int)$t[1],(int)$t[2],(int)$d[1],(int)$d[2],(int)$d[0]);
        return $time_stamp;
    }
    
    // get hour
    function getHour(){
        $time = explode(" ", $this->time);
        $t = explode(":", $time[1]);
        return $t[0];
    }
    
    // get hour
    function getHourPV(){
        $hour = array();
        $h = $this->getHour();
        $hour[$h] += 1;
        $t_log_arr = $this->track;
        while(list($key,$t_log) = each($t_log_arr)){
            $t_time = $t_log->getTrackInfo('Time');
            $time = explode(" ", $t_time);
            $h = explode(":", $time[1]);
            $h_key = $h[0];
            $hour[$h_key] += 1;
        }
        return $hour;
    }
    
    // get infomation of session log
    function getSessInfo($mode){
        switch($mode){
            case "PageView":
                return $this->getPageView();
            case "TimeStamp":
                return $this->getTimeStamp();
            case "Hour":
                return $this->getHour();
            case "HourPV":
                return $this->getHourPV();
            case "Time":
                return $this->time;
            case "Ip":
                return $this->ip;
            case "AccUrl":
                return $this->accUrl;
            case "RefUrl":
                return $this->refUrl;
            case "Host":
                return $this->host;
            case "Agent":
                return $this->agent;
            case "Screen":
                return $this->screen;
            case "Color":
                return $this->color;
            case "Java":
                return $this->java;
            case "JavaScript":
                return $this->javaScript;
            case "Track":
                return $this->track;
            default:
                return false;
        }
    }
}
?>
